#!/usr/bin/env python
# -*- coding: utf-8 -*-

import serial
import struct
import rospy
from sensor_msgs.msg import LaserScan
import math

ser = serial.Serial("/dev/ttyAMA0",115200)

kSync1 = 0x55
kSync2 = 0xaa
kSync3 = 0x03
kSync4 = 0x08

offset = -15

ranges =[0] * 9
intensities =[0] * 9
start_angle = 0
end_angle = 0
angle_res = 0

pub = rospy.Publisher('scan',LaserScan, queue_size=50)
rospy.init_node('camsense_x1')


def CamsenseX1_parse():
    State = 'SYNC1'
    buf = [0]
    bufU =[0]
    bufL =[0]
    frame_data = [0] * 100
    global    ranges
    global    intensities
    global    start_angle
    global    end_angle
    global    angle_res

    ser.reset_input_buffer()  #add 20201102
    while 1:
        if State == 'SYNC1':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync1:
                        State = 'SYNC2'
        elif State == 'SYNC2':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync2:
                        State = 'SYNC3'
                else:
                        State = 'SYNC1'
        elif State == 'SYNC3':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync3:
                        State = 'SYNC4'
                else:
                        State = 'SYNC1'
        elif State == 'SYNC4':
                buf = list(struct.unpack_from("B",ser.read(),0))
                if buf[0] == kSync4:
                        State = 'SPEED'
                else:
                        State = 'SYNC1'
        elif State == 'SPEED':
                bufL = list(struct.unpack_from("B",ser.read(),0))
                bufU = list(struct.unpack_from("B",ser.read(),0))
                speed = bufU[0] << 8 | bufL[0]
                State = 'START'
        elif State == 'START':
                bufL = list(struct.unpack_from("B",ser.read(),0))
                bufU = list(struct.unpack_from("B",ser.read(),0))
                count  = bufU[0] << 8 | bufL[0]
                start_angle = (count / 64.0) - 640
                State = 'DATA'
        elif State == 'DATA':
                for d in range(24):
                        buf = list(struct.unpack_from("B",ser.read(),0))
                        frame_data[d] = buf[0]
                State = 'END'
        elif State == 'END':
                bufL = list(struct.unpack_from("B",ser.read(),0))
                bufU = list(struct.unpack_from("B",ser.read(),0))
                count = bufU[0] << 8 | bufL[0]
                end_angle =  (count / 64.0) - 640
                State = 'CRC'
        elif State == 'CRC':
                buf = list(struct.unpack_from("B",ser.read(2),0))
                if end_angle < start_angle:
                        angle_res = ( end_angle + 360 - start_angle ) / 8.0
                else:
                        angle_res = ( end_angle - start_angle ) / 8.0
                for i in range(8):
                        j = 3 * i
                        lrange = int(frame_data[j+1]) << 8 | frame_data[j]
                        intensity = frame_data[j+2]
                        if lrange == 0x8000:
                        lrange = 8000
                        ranges[i] = float(lrange)/1000.0
                        intensities[i] = intensity

                print "***********  DATA OUT *************"
                print "start angle",
                print start_angle
                print "end angle",
                print end_angle
                print "speed",
                print speed
                print "angle res",
                print angle_res
                print "ranges",
                print ranges
                print "intensiteies",
                print intensities
                State = 'SYNC1'
                break
        else:
                pass
def sendtopic():
        current_time = rospy.Time.now()
        scan = LaserScan()
        scan.header.stamp = current_time
        scan.header.frame_id = 'scan'
        scan.angle_min = math.radians(360 - end_angle + offset)
        scan.angle_max = math.radians(360 - start_angle + offset)
        scan.range_min = 0.008
        scan.range_max = 8
        scan.angle_increment = math.radians(angle_res)
        scan.time_increment = 0.001
        scan.ranges = []
        scan.intensities = []
        for i in range(8):
                scan.ranges.append(ranges[7-i])
                scan.intensities.append(intensities[7-i])
        pub.publish(scan)


print("Start")
while not rospy.is_shutdown(): # modify 20201102
        CamsenseX1_parse()
        sendtopic()
