#!/usr/bin/env python
# -*- coding: utf-8 -*-
import rospy
import math
import time
import sys
import serial
import time
import json
import struct
import tf_conversions
import tf2_ros
import geometry_msgs.msg
import turtlesim.msg
import FaBo9Axis_MPU9250

enc_data = {}
ser = serial.Serial("/dev/ttyUSB0",115200)

mpu9250 = FaBo9Axis_MPU9250.MPU9250()

magXmax = 66
magXmin = -10
magYmax = 132
magYmin = 62

adjX  = 200 / (magXmax - magXmin)
adjY  = 200 / (magYmax - magYmin)
offsetX = magXmax - ((magXmax - magXmin)/2)
offsetY = magYmax - ((magYmax - magYmin)/2)

adj_m = (10.0 / 85)/1000
ser.write(b"R")

def getEncoder_data():
    global enc_data
    line = ser.readline()
    line = line.rstrip()
    try:
        enc_data  = json.loads(line)
        return 1
    except:
        print "json data load error"
        return 0

def readcompass():
    mag = mpu9250.readMagnet()
    mx = (mag['x'] - offsetX) * adjX
    my = (mag['y'] - offsetY) * adjY
    bearing  = math.atan2(my, mx)
    if (bearing < 0):
        bearing += 2 * math.pi
    return math.trunc(math.degrees(bearing))

def TF_bloadcast():
    x = 0
    y = 0
    count = 0
    defguf = 0
    theta = 0
    while not rospy.is_shutdown(): # modify 20201102
        if count == 4:
           theta = readcompass()
           count = 0
           print("theta:",theta)
           theta = math.radians(theta)
        print("theta:",theta)

        if getEncoder_data() == 1:
           Rx = enc_data['ENC_R']
           Lx = enc_data['ENC_L']
           print("ENC_R",Rx)
           print("ENC_L",Lx)
           ser.write(b"R")
           move_x = (Rx+Lx)/2
           x += move_x * math.cos(theta)
           y += move_x * math.sin(theta)
           print("x",x)
           print("y",y)

        else:
           pass

        br = tf2_ros.TransformBroadcaster()
        t = geometry_msgs.msg.TransformStamped()
        t.header.stamp = rospy.Time.now()
        t.header.frame_id = 'odom'
        t.child_frame_id = 'base_link'
        t.transform.translation.x = x * adj_m
        t.transform.translation.y = y * adj_m
        t.transform.translation.z = 0
        q = tf_conversions.transformations.quaternion_from_euler(0, 0, theta)
        t.transform.rotation.x = q[0]
        t.transform.rotation.y = q[1]
        t.transform.rotation.z = q[2]
        t.transform.rotation.w = q[3]

        br.sendTransform(t)

        count +=1

        time.sleep(0.05)

if __name__ == '__main__':
    rospy.init_node('tf2_broadcaster')
    TF_bloadcast()
    rospy.spin()